Bug 998636 - Review Request: gocl - GLib/GObject based library for OpenCL
Review Request: gocl - GLib/GObject based library for OpenCL
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Björn "besser82" Esser
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-19 12:22 EDT by Fabian Deutsch
Modified: 2013-10-18 15:41 EDT (History)
3 users (show)

See Also:
Fixed In Version: gocl-0.1.6-1.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-12 00:29:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
fedora: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Fabian Deutsch 2013-08-19 12:22:41 EDT
Spec URL: https://raw.github.com/fabiand/gocl-spec/0.1.4-1/gocl.spec
SRPM URL: http://fedorapeople.org/~fabiand/gocl/gocl-0.1.4-1.fc19.src.rpm
Description:
Gocl is a GLib/GObject based library that aims at simplifying the use of OpenCL in GNOME software. It is intended to be a lightweight wrapper that adapts OpenCL programming patterns and boilerplate, and expose a simpler API that is known and comfortable to GNOME developers. Examples of such adaptations are the integration with GLib’s main loop, exposing non-blocking APIs, GError based error reporting and full gobject-introspection support. It will also be including convenient API to simplify code for the most common use patterns.

Fedora Account System Username: fabiand
Comment 1 Fabian Deutsch 2013-08-19 12:26:36 EDT
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=5830417

$ rpmlint gocl.spec 
gocl.spec:10: W: macro-in-comment %{name}
gocl.spec:10: W: macro-in-comment %{version}
gocl.spec:10: W: macro-in-comment %{name}
gocl.spec:10: W: macro-in-comment %{version}
gocl.spec: W: invalid-url Source0: gocl-0.1.4.tar.gz
0 packages and 1 specfiles checked; 0 errors, 5 warnings.

Warnings are due to the fact that I describe how to curl the source from github.
Comment 2 Fabian Deutsch 2013-08-19 12:33:31 EDT
$ koji-download-scratch 5830417
$ rpmlint *.rpm
gocl.armv7hl: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.armv7hl: W: spelling-error %description -l en_US gobject -> object, g object
gocl.i686: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.i686: W: spelling-error %description -l en_US gobject -> object, g object
gocl.src: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.src: W: spelling-error %description -l en_US gobject -> object, g object
gocl.src:10: W: macro-in-comment %{name}
gocl.src:10: W: macro-in-comment %{version}
gocl.src:10: W: macro-in-comment %{name}
gocl.src:10: W: macro-in-comment %{version}
gocl.src: W: invalid-url Source0: gocl-0.1.4.tar.gz
gocl.x86_64: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.x86_64: W: spelling-error %description -l en_US gobject -> object, g object
10 packages and 0 specfiles checked; 0 errors, 13 warnings.

IMHO nothing serious.
Comment 3 Fabian Deutsch 2013-08-19 13:14:16 EDT
PPC Builds:
http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=1343909
Comment 4 Fabian Deutsch 2013-08-26 05:33:04 EDT
Anyone?
Comment 5 Björn "besser82" Esser 2013-09-11 08:53:14 EDT
Package has some issues.

#####

Package Review
==============

Legend:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.

     ---> License is fine.

[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gtk-doc, /usr/share
     /gtk-doc/html, /usr/lib64/girepository-1.0, /usr/share/gir-1.0

     ---> please Requires a package which ownes these or make your
          package own them, if this is more convinient.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments

     ---> Why don't you use the gh-tag for Source0?

[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define api_version 0.1

     ---> Why don't use %global?

[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).

     ---> What???

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Package should not use obsolete m4 macros


Rpmlint
-------
Checking: gocl-0.1.4-1.fc21.x86_64.rpm
          gocl-devel-0.1.4-1.fc21.x86_64.rpm
          gocl-0.1.4-1.fc21.src.rpm
gocl.x86_64: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.x86_64: W: spelling-error %description -l en_US gobject -> object, g object
gocl.x86_64: E: description-line-too-long C Gocl is a GLib/GObject based library that aims at simplifying the use of OpenCL in GNOME software. It is intended to be a lightweight wrapper that adapts OpenCL programming patterns and boilerplate, and expose a simpler API that is known and comfortable to GNOME developers. Examples of such adaptations are the integration with GLib’s main loop, exposing non-blocking APIs, GError based error reporting and full gobject-introspection support. It will also be including convenient API to simplify code for the most common use patterns.
gocl.src: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.src: W: spelling-error %description -l en_US gobject -> object, g object
gocl.src: E: description-line-too-long C Gocl is a GLib/GObject based library that aims at simplifying the use of OpenCL in GNOME software. It is intended to be a lightweight wrapper that adapts OpenCL programming patterns and boilerplate, and expose a simpler API that is known and comfortable to GNOME developers. Examples of such adaptations are the integration with GLib’s main loop, exposing non-blocking APIs, GError based error reporting and full gobject-introspection support. It will also be including convenient API to simplify code for the most common use patterns.
gocl.src:10: W: macro-in-comment %{name}
gocl.src:10: W: macro-in-comment %{version}
gocl.src:10: W: macro-in-comment %{name}
gocl.src:10: W: macro-in-comment %{version}
gocl.src: W: invalid-url Source0: gocl-0.1.4.tar.gz
3 packages and 0 specfiles checked; 2 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint gocl-devel gocl
gocl.x86_64: W: spelling-error Summary(en_US) GLib -> G Lib, Glib, Gib
gocl.x86_64: W: spelling-error %description -l en_US gobject -> object, g object
gocl.x86_64: E: description-line-too-long C Gocl is a GLib/GObject based library that aims at simplifying the use of OpenCL in GNOME software. It is intended to be a lightweight wrapper that adapts OpenCL programming patterns and boilerplate, and expose a simpler API that is known and comfortable to GNOME developers. Examples of such adaptations are the integration with GLib’s main loop, exposing non-blocking APIs, GError based error reporting and full gobject-introspection support. It will also be including convenient API to simplify code for the most common use patterns.
gocl.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgocl-0.1.so.0.0.1 /lib64/libgthread-2.0.so.0
gocl.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgocl-0.1.so.0.0.1 /lib64/libpthread.so.0
2 packages and 0 specfiles checked; 1 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
gocl-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    gocl(x86-64)
    libgocl-0.1.so.0()(64bit)
    pkgconfig(gio-2.0)
    pkgconfig(glib-2.0)
    pkgconfig(gobject-2.0)

gocl (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libOpenCL.so.1()(64bit)
    libOpenCL.so.1(OPENCL_1.0)(64bit)
    libOpenCL.so.1(OPENCL_1.1)(64bit)
    libOpenCL.so.1(OPENCL_1.2)(64bit)
    libc.so.6()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
gocl-devel:
    gocl-devel
    gocl-devel(x86-64)
    pkgconfig(gocl-0.1)

gocl:
    gocl
    gocl(x86-64)
    libgocl-0.1.so.0()(64bit)



Diff spec file in url and in SRPM
---------------------------------
--- /home/besser82/shared/fedora/review/998636-gocl/srpm/gocl.spec	2013-09-11 13:38:08.901823432 +0200
+++ /home/besser82/shared/fedora/review/998636-gocl/srpm-unpacked/gocl.spec	2013-08-19 18:13:34.000000000 +0200
@@ -22,13 +22,5 @@
 
 %description
-Gocl is a GLib/GObject based library that aims at simplifying the
-use of OpenCL in GNOME software. It is intended to be a lightweight
-wrapper that adapts OpenCL programming patterns and boilerplate, and
-expose a simpler API that is known and comfortable to GNOME
-developers. Examples of such adaptations are the integration with
-GLib’s main loop, exposing non-blocking APIs, GError based error
-reporting and full gobject-introspection support. It will also be
-including convenient API to simplify code for the most common use
-patterns. 
+Gocl is a GLib/GObject based library that aims at simplifying the use of OpenCL in GNOME software. It is intended to be a lightweight wrapper that adapts OpenCL programming patterns and boilerplate, and expose a simpler API that is known and comfortable to GNOME developers. Examples of such adaptations are the integration with GLib’s main loop, exposing non-blocking APIs, GError based error reporting and full gobject-introspection support. It will also be including convenient API to simplify code for the most common use patterns. 
 
 


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 998636
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

#####

Why is there an empty %doc in the -devel pkg?  Did you miss to include the examples?

#####

Please fix those issues and I'll grant review.  :)
Comment 6 Fabian Deutsch 2013-09-11 10:01:01 EDT
SRPM URL:
http://kojipkgs.fedoraproject.org//work/tasks/2943/5922943/gocl-0.1.4-2.fc19.src.rpm

Spec URL:
https://raw.github.com/fabiand/gocl-spec/0.1.4-2/gocl.spec

Task info:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5922940 (19)
http://koji.fedoraproject.org/koji/taskinfo?taskID=5923001 (20)
http://koji.fedoraproject.org/koji/taskinfo?taskID=5923015 (rawhide)

> [!]: Package must own all directories that it creates.
>      Note: Directories without known owners: /usr/share/gtk-doc, /usr/share
>      /gtk-doc/html, /usr/lib64/girepository-1.0, /usr/share/gir-1.0
> 
>      ---> please Requires a package which ownes these or make your
>           package own them, if this is more convinient.

Owning the dirs, like the other packages do it too.

> [!]: Spec use %global instead of %define unless justified.
>      Note: %define requiring justification: %define api_version 0.1
> 
>      ---> Why don't use %global?

It is now.

> Generic:
> [!]: Spec file according to URL is the same as in SRPM.
>      Note: Spec file as given by url is not the same as in SRPM (see attached
>      diff).
> 
>      ---> What???

I must have been sleepy. Sorry.

> Why is there an empty %doc in the -devel pkg?  Did you miss to include the
> examples?

Example sources now in doc.
Comment 7 Björn "besser82" Esser 2013-09-11 10:14:01 EDT
package is fine now ;)

APPROVED!!!
Comment 8 Fabian Deutsch 2013-09-11 10:44:46 EDT
New Package SCM Request
=======================
Package Name: gocl
Short Description: GLib/GObject based library for OpenCL 
Owners: fabiand
Branches: f19 f20
InitialCC: besser82
Comment 9 Jon Ciesla 2013-09-11 12:45:57 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2013-09-25 15:45:48 EDT
gocl-0.1.4-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/gocl-0.1.4-3.fc20
Comment 11 Fedora Update System 2013-09-25 15:45:59 EDT
gocl-0.1.4-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/gocl-0.1.4-3.fc19
Comment 12 Fedora Update System 2013-09-26 20:34:42 EDT
gocl-0.1.4-3.fc20 has been pushed to the Fedora 20 testing repository.
Comment 13 Fedora Update System 2013-10-01 10:19:01 EDT
gocl-0.1.6-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/gocl-0.1.6-1.fc20
Comment 14 Fedora Update System 2013-10-01 10:19:21 EDT
gocl-0.1.6-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/gocl-0.1.6-1.fc19
Comment 15 Fedora Update System 2013-10-02 03:52:22 EDT
gocl-0.1.6-2.fc20,ocl-icd-2.0.4-1.git20131001.4ee231e.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/gocl-0.1.6-2.fc20,ocl-icd-2.0.4-1.git20131001.4ee231e.fc20
Comment 16 Fedora Update System 2013-10-12 00:29:17 EDT
gocl-0.1.6-2.fc20, ocl-icd-2.0.4-1.git20131001.4ee231e.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2013-10-18 15:41:38 EDT
gocl-0.1.6-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.